<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 10/11/2004 *
 * ================                             Last change: 10/11/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-cache.php                                    *
 * -------------------------------------------------------------------- *
 * Short description : Caching system for SQL tables on hard disc       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Caching-System zum Auslagern von SQL-Tabellen    *
 *                     auf der Festplatte des Servers                   *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
EXT_SET_VERSION('0.2.2');

// Version history array (add more with , '0.1.0' and so on)
EXT_SET_VER_HISTORY(array('0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6', '0.0.7', '0.0.8', '0.0.9', '0.1.0', '0.1.1', '0.1.2', '0.1.3', '0.1.4', '0.1.5', '0.1.6', '0.1.7', '0.1.8', '0.1.9', '0.2.0', '0.2.1', '0.2.2'));

switch ($EXT_LOAD_MODE)
{
case 'register': // Do stuff when installation is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_update BIGINT(20) UNSIGNED NOT NULL DEFAULT 3600");
	ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_path VARCHAR(255) NOT NULL DEFAULT 'cache/'");
	ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_tested TINYINT(1) UNSIGNED NOT NULL DEFAULT 0");
	ADD_EXT_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('setup','config_cache','Cache-Einstellungen','Update-Interval des Caches usw. k&ouml;nnen Sie hier &auml;ndern.', 9)");
	break;

case 'remove': // Do stuff when removing extension
	// SQL commands to run
	ADD_EXT_SQL("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_admin_menu` WHERE `what` IN('config_cache','cache_stats')");

	// Unregister all filters
	UNREGISTER_FILTER('extension_update', 'CACHE_DESTROY_ON_EXT_CHANGE', true, $dry_run);
	UNREGISTER_FILTER('post_extension_installed', 'CACHE_DESTROY_ON_EXT_CHANGE', true, $dry_run);
	UNREGISTER_FILTER('post_extension_installed', 'CACHE_PURGE_ADMIN_MENU', true, $dry_run);
	UNREGISTER_FILTER('post_extension_run_sql', 'CACHE_DESTROY_ON_EXT_CHANGE', true, $dry_run);
	UNREGISTER_FILTER('post_extension_run_sql', 'CACHE_PURGE_ADMIN_MENU', true, $dry_run);
	UNREGISTER_FILTER('post_admin_added', 'CACHE_DESTROY_ON_ADMIN_CHANGE', true, $dry_run);
	UNREGISTER_FILTER('post_admin_edited', 'CACHE_DESTROY_ON_ADMIN_CHANGE', true, $dry_run);
	UNREGISTER_FILTER('post_admin_deleted', 'CACHE_DESTROY_ON_ADMIN_CHANGE', true, $dry_run);
	UNREGISTER_FILTER('post_admin_reset_pass', 'CACHE_DESTROY_ON_ADMIN_CHANGE', true, $dry_run);
	UNREGISTER_FILTER('extension_remove', 'CACHE_DESTROY_ALL', true, $dry_run);
	break;

case 'activate': // Do stuff when admin activates this extension
	// SQL commands to run
	ADD_EXT_SQL("");
	break;

case 'deactivate': // Do stuff when admin deactivates this extension
	// SQL commands to run
	ADD_EXT_SQL("");
	break;

case 'update': // Update an extension
	switch ($EXT_VER)
	{
	case '0.0.1': // SQL queries for v0.0.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Es wurde die Zeitmarke der Cache-Datei extensions.cache mit ber&uuml;cksichtigt. Dies hatte die Folge, dass wenn bei einem Gast die Datei aktualisiert wurde, nur aktivierte und nicht die deaktivierten mit geladen wurden. Folglich fiehlen einfach ein paar Erweiterungen aus.");
		break;

	case '0.0.2': // SQL queries for v0.0.2
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
		break;

	case '0.0.3': // SQL queries for v0.0.3
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Cache-Update repariert.");
		break;

	case '0.0.4': // SQL queries for v0.0.4
		// Is the cache extension itself there?
		if (EXT_IS_ACTIVE('cache')) {
			// Check for cache when extension is already installed
			if ($GLOBALS['cache_instance']->loadCacheFile("extensions", true)) $GLOBALS['cache_instance']->destroyCacheFile();
		} // END - if

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Spalte &quot;keep_active&quot; ist hinzugef&uuml;gt. Cache wurde reinitialisiert.");
		break;

	case '0.0.5': // SQL queries for v0.0.5
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Registrierung der Cache-Erweiterung repariert");
		break;

	case '0.0.6': // SQL queries for v0.0.6
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Validierung der Cache-Datei admins.cache integriert.");
		break;

	case '0.0.7': // SQL queries for v0.0.7
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD db_hits BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_hits BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");
		ADD_EXT_SQL("INSERT INTO `{!_MYSQL_PREFIX!}_admin_menu` (`action`,`what`,`title`,`descr`,`sort`) VALUES ('stats','cache_stats','DB-Cache','Auf Cache und gesamte Datenbank registrierte Anfragen anzeigen.', 4)");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Hits auf den Cache werden gez&auml;hlt.");
		break;

	case '0.0.8': // SQL queries for v0.0.8
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Das Umschreiben der Cache-Daten hat eine Fehlermeldung <strong>Falsches Passwort!</strong> im Admin-Bereich verursacht.");
		break;

	case '0.0.9': // SQL queries for v0.0.9
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Interne Datenfeld-Management korregiert und Cache-Statistiken korregiert.");
		break;

	case '0.1.0': // SQL queries for v0.2.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Problem mit fehlender admins-Erweiterung beseitigt.");
		break;

	case '0.1.1': // SQL queries for v0.1.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehler <strong>Division durch 0</strong> repariert in den DB-Cache Statistiken.");
		break;

	case '0.1.2': // SQL queries for v0.1.2
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Die Tabelen <strong>{!_MYSQL_PREFIX!}_config</strong>, <strong>{!_MYSQL_PREFIX!}_refsystem</strong>, <strong>{!_MYSQL_PREFIX!}_refdepths</strong> und <strong>{!_MYSQL_PREFIX!}_mod_reg</strong> werden nun auch ausgelagert.");
		break;

	case '0.1.3': // SQL queries for v0.1.3
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_admins ENUM('Y','N') NOT NULL DEFAULT 'Y'");
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_acls ENUM('Y','N') NOT NULL DEFAULT 'Y'");
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_exts ENUM('Y','N') NOT NULL DEFAULT 'Y'");
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_config ENUM('Y','N') NOT NULL DEFAULT 'Y'");
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_modreg ENUM('Y','N') NOT NULL DEFAULT 'Y'");
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_refdepth ENUM('Y','N') NOT NULL DEFAULT 'Y'");
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_refsys ENUM('Y','N') NOT NULL DEFAULT 'Y'");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Alle cache-baren Tabellen sind nun einzelnt ein- bzw. ausschaltbar. Falls die eine oder andere ausgelagerte Tabelle also Fehler verursachen sollte, so k&ouml;nnen Sie diese hier abschalten. Beachten Sie aber bitte, dass dann mehr Abfragen an die Datenbank gestellt wird und dies bedeutend mehr Zeit braucht, als nur die Daten aus einem Datenfeld zu laden, das sich im Speicher aufh&auml;lt.");
		break;

	case '0.1.4': // SQL queries for v0.1.4
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehler <strong>Division durch 0</strong> repariert in <strong>inc/load_cache.php</strong>.");
		break;

	case '0.1.5': // SQL queries for v0.1.5
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Weitere Fehler im System beseitigt.");
		break;

	case '0.1.6': // SQL queries for v0.1.6
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Probleme w&auml;hrend des Installationsvorganges beseitigt.");
		break;

	case '0.1.7': // SQL queries for v0.1.7
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("CSS-Klassenname gefixt in Templates.");
		break;

	case '0.1.8': // SQL queries for v0.1.8
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_themes ENUM('Y','N') NOT NULL DEFAULT 'Y'");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Daten von installierten Themes werden nun gecacht.");
		break;

	case '0.1.9': // SQL queries for v0.1.9
		ADD_EXT_SQL("ALTER TABLE `{!_MYSQL_PREFIX!}_config` ADD cache_admin_menu ENUM('Y','N') NOT NULL DEFAULT 'N'");

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Administratormen&uuml; experimentell gecacht.");
		break;

	case '0.2.0': // SQL queries for v0.2.0
		// This update depends on sql_patches
		EXT_ADD_UPDATE_DEPENDS('sql_patches');

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Die Erweiterung h&auml;ngt nun von der <strong>sql_patches</strong> ab.");
		break;

	case '0.2.1': // SQL queries for v0.2.1
		// Register the new filter
		REGISTER_FILTER('extension_update', 'CACHE_DESTROY_ON_EXT_CHANGE', false, true, $dry_run);
		REGISTER_FILTER('post_extension_installed', 'CACHE_DESTROY_ON_EXT_CHANGE', false, true, $dry_run);
		REGISTER_FILTER('post_extension_run_sql', 'CACHE_DESTROY_ON_EXT_CHANGE', false, true, $dry_run);
		REGISTER_FILTER('post_admin_added', 'CACHE_DESTROY_ON_ADMIN_CHANGE', false, true, $dry_run);
		REGISTER_FILTER('post_admin_edited', 'CACHE_DESTROY_ON_ADMIN_CHANGE', false, true, $dry_run);
		REGISTER_FILTER('post_admin_deleted', 'CACHE_DESTROY_ON_ADMIN_CHANGE', false, true, $dry_run);
		REGISTER_FILTER('post_admin_reset_pass', 'CACHE_DESTROY_ON_ADMIN_CHANGE', false, true, $dry_run);
		REGISTER_FILTER('extension_remove', 'CACHE_DESTROY_ALL', false, true, $dry_run);

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Filter f&uuml;r Erweiterungsmanagement hinzugef&uuml;gt.");
		break;

	case '0.2.2': // SQL queries for v0.2.2
		// Register the new filter
		REGISTER_FILTER('post_extension_installed', 'CACHE_PURGE_ADMIN_MENU', false, true, $dry_run);
		REGISTER_FILTER('post_extension_run_sql', 'CACHE_PURGE_ADMIN_MENU', false, true, $dry_run);

		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Weitere Filter hinzugef&uuml;gt.");
		break;
	}
	break;

case 'modify': // When the extension got modified
	break;

case 'test': // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
	break;

default: // Do stuff when extension is loaded
	// Create instance on class
	if ($GLOBALS['cache_mode'] != "init") {
		// Initialize cache system only when it's needed
		$GLOBALS['cache_instance'] = new CacheSystem(getConfig('cache_update'), "inc/".getConfig('cache_path'), getConfig('cache_tested'));
		if ($GLOBALS['cache_instance']->getStatus() != "done") {
			// Failed to initialize cache sustem
			addFatalMessage(__FILE__, __LINE__, "(<font color=\"#0000aa\">".__LINE__."</font>): ".getMessage('CACHE_CANNOT_INITIALIZE'));
		} // END - if
	} // END - if
	break;
}

// Keep this extension always active!
EXT_SET_ALWAYS_ACTIVE("Y");

//
?>
