<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/22/2004 *
 * ================                             Last change: 07/08/2007 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-mailid.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Mail confirmation link                           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mailbestaetigungslink                            *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
EXT_SET_VERSION('0.3.3');

// Version history array (add more with , '0.1.0' and so on)
EXT_SET_VER_HISTORY(array('0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6', '0.0.7', '0.0.8', '0.0.9', '0.1.0', '0.1.1', '0.1.2', '0.1.3', '0.1.4', '0.1.5', '0.1.6', '0.1.7', '0.1.8', '0.1.9', '0.2.0', '0.2.1', '0.2.2', '0.2.3', '0.2.4', '0.2.5', '0.2.6', '0.2.7', '0.2.8', '0.2.9', '0.3.0', '0.3.1', '0.3.2', '0.3.3'));

switch ($EXT_LOAD_MODE)
{
case 'register': // Do stuff when installation is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	ADD_EXT_SQL("");
	break;

case 'remove': // Do stuff when removing extension
	// SQL commands to run
	ADD_EXT_SQL("");
	break;

case 'activate': // Do stuff when admin activates this extension
	// SQL commands to run
	ADD_EXT_SQL("UPDATE `{!_MYSQL_PREFIX!}_mod_reg` SET `locked`='N', `hidden`='N', `admin_only`='N', `mem_only`='N' WHERE `module`='mailid' LIMIT 1");
	break;

case 'deactivate': // Do stuff when admin deactivates this extension
	// SQL commands to run
	ADD_EXT_SQL("UPDATE `{!_MYSQL_PREFIX!}_mod_reg` SET `locked`='Y' WHERE `module`='mailid' LIMIT 1");
	break;

case 'update': // Update an extension
	switch ($EXT_VER)
	{
	case '0.0.1': // SQL queries for v0.0.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Veraltetes Update.");
		break;

	case '0.0.2': // SQL queries for v0.0.2
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Turbo-Bonus interegiert, nur wenn bonus-Erweiterung v0.2.2 oder h&ouml;her ist.");
		break;

	case '0.0.4': // SQL queries for v0.0.4
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Absicherung der Variablen <em>uid</em>, <em>mailid</em> und <em>bonusid</em> durch die eigene Funktion <em>bigintval()</em> in den beiden Dateien <em>mailid.php</em> und <em>mailid_top.php</em>.");
		break;

	case '0.0.5': // SQL queries for v0.0.5
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Weisse Seite im Mozilla bzw. <em>Seite nicht gefunden</em> unter dem IE behoben.");
		break;

	case '0.0.6': // SQL queries for v0.0.6
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("register_globals-Problem behoben");
		break;

	case '0.0.7': // SQL queries for v0.0.7
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
		break;

	case '0.0.8': // SQL queries for v0.0.8
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
		break;

	case '0.0.9': // SQL queries for v0.0.9
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Mailbest&auml;tigung klappt wieder.");
		break;

	case '0.1.0': // SQL queries for v0.2.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("5 Nachkommastellen implementiert");
		break;

	case '0.1.1': // SQL queries for v0.1.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
		break;

	case '0.1.2': // SQL queries for v0.1.2
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Probe-Fix wegen falschen Best&auml;tigungcodes bei Druck auf Return-Taste. Bitte aktualisieren Sie auch das Template <u>mailid_confirm_buttom.tpl</u>, damit die Best&auml;tigung ohne Code auch klappt!");
		break;

	case '0.1.3': // SQL queries for v0.1.3
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Men&uuml;punkte im Gast-/Mitgliedsbereich k&ouml;nnen nicht mehr aufgerufen werden, wenn die Erweiterung deaktiviert ist.");
		break;

	case '0.1.4': // SQL queries for v0.1.4
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Sicherheitsupdate an den Scripten <u>mailid.php</u> und <strong>mailid_top.php</strong> durchgef&uuml;hrt.");
		break;

	case '0.1.5': // SQL queries for v0.1.5
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Sende-Pool wird nicht mehr ben&ouml;tigt, um die Best&auml;tigung durchzuf&uuml;hren.");
		break;

	case '0.1.6': // SQL queries for v0.1.6
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Template <u>mailid_frameset.tpl</u> nach <u>mailid_frames.tpl</u> umbenannt.");
		break;

	case '0.1.7': // SQL queries for v0.1.7
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Ausgabe des generierten HTML-Codes nach <u>inc/footer.php</u> verlagert.");
		break;

	case '0.1.8': // SQL queries for v0.1.8
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehlende Variablen gefixt.");
		break;

	case '0.1.9': // SQL queries for v0.1.9
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Gesamt-{!POINTS!} werden nun nach Best&auml;tigung angezeigt. Bitte aktualisieren Sie die Templates <u>mailid_points_done.tpl</u>, <u>mailid_points_done2.tpl</u> und <u>mailid_frames.tpl</u> !");
		break;

	case '0.2.0': // SQL queries for v0.2.0
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Variablen abgesichert (Diverse Warnhinweise des Webservers sind damit unterbunden).");
		break;

	case '0.2.1': // SQL queries for v0.2.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Parser-Fehler beseitigt.");
		break;

	case '0.2.2': // SQL queries for v0.2.2
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehler wegen fehlende Datenfeldelementen behoben.");
		break;

	case '0.2.3': // SQL queries for v0.2.3
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Modul <strong>mailid</strong> war nicht gesetzt. Dadurch wurden die URLs (loader z.B.) umgeschrieben und f&uuml;hrten somit zu Fehlern.");
		break;

	case '0.2.4': // SQL queries for v0.2.4
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Vorbereitung auf die neue Mediendaten v0.0.4.");
		break;

	case '0.2.5': // SQL queries for v0.2.5
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Den Punkte in der Gesamt-{!POINTS!}-Anzahl in ein Komma umgewandelt.");
		break;

	case '0.2.6': // SQL queries for v0.2.6
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("De-/Aktivieren des mit dieser Erweiterung verkn&uuml;pften Modules eingebunden.");
		break;

	case '0.2.7': // SQL queries for v0.2.7
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Wenn die {!POINTS!} dem <strong>noch auf Auszahlung wartendem Guthaben</strong> aufaddiert wird, wird eine entsprechende Nachricht ausgegeben (neue Templates <strong>mailid_points_locked</strong> und <strong>mailid_points_locked2</strong> sind hinzugekommen!)");
		break;

	case '0.2.8': // SQL queries for v0.2.8
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Bonus- und Standart-Referal-ID ausblendbar aus Aktiv-Rallye und bekommt kein Aktiv-Guthaben.");
		break;

	case '0.2.9': // SQL queries for v0.2.9
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("<strong>Code wiederholen</strong> nach <strong>Code eingeben</strong> hin ge&auml;ndert.");
		break;

	case '0.3.0': // SQL queries for v0.3.0
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehlende Templates hinzugef&uuml;gt.");
		break;

	case '0.3.1': // SQL queries for v0.3.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("mailid.php und mailid_top.php k&ouml;nnen erst bei aktivierter Erweiterung <strong>mailid</strong> benutzt werden. Solange gibt es fatale Fehlermeldungen.");
		break;

	case '0.3.2': // SQL queries for v0.3.2
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Bitte das Template <em><strong>{!PATH!}/templates/de/html/mailid/mailid_points_lcoked2.tpl</strong></em> l&ouml;schen. Noices fixed.");
		break;

	case '0.3.3': // SQL queries for v0.3.3
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Variablen-Handling skriptglobal ge&auml;ndert.");
		break;
	}
	break;

case 'modify': // When the extension got modified
	break;

case 'test': // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
	break;

default: // Do stuff when extension is loaded
	break;
}

//
?>
