<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/01/2004 *
 * ================                             Last change: 12/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-profile.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Profile update notificatios                      *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Profilaktualisierungserinnerungen                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
EXT_SET_VERSION('0.0.9');

// Version history array (add more with , '0.1.0' and so on)
EXT_SET_VER_HISTORY(array('0.0', '0.0.1', '0.0.2', '0.0.3', '0.0.4', '0.0.5', '0.0.6', '0.0.7', '0.0.8', '0.0.9'));

switch ($EXT_LOAD_MODE)
{
case 'register': // Do stuff when installation is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	ADD_EXT_SQL("");
	break;

case 'remove': // Do stuff when removing extension
	// SQL commands to run
	ADD_EXT_SQL("");
	break;

case 'activate': // Do stuff when admin activates this extension
	// SQL commands to run
	ADD_EXT_SQL("");
	break;

case 'deactivate': // Do stuff when admin deactivates this extension
	// SQL commands to run
	ADD_EXT_SQL("");
	break;

case 'update': // Update an extension
	switch ($EXT_VER)
	{
	case '0.0.1': // SQL queries for v0.0.1
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Benachrichtungsmails werden nur beim t&auml;gichen Reset ausgesendet");
		break;

	case '0.0.2': // SQL queries for v0.0.2
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Fehler beseitigt, wenn error_reporting=E_ALL gesetzt ist.");
		break;

	case '0.0.3': // SQL queries for v0.0.3
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("5 Nachkommastellen implementiert");
		break;

	case '0.0.4': // SQL queries for v0.0.4
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Dummy-Release im Intranet??? Hmmm...");
		break;

	case '0.0.5': // SQL queries for v0.0.5
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Profilaktualisierungsmails werden nur dann ausgesendet, wenn <u>profile_update</u> und <u>prof_reupdate</u> &gt; 0 sind.");
		break;

	case '0.0.6': // SQL queries for v0.0.6
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Datumsformat festgelegt auf ausf&uuml;hrlich.");
		break;

	case '0.0.7': // SQL queries for v0.0.7
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("W&ouml;rter <strong>Mailtausch</strong>, <strong>Mailtausches</strong> und <strong>Mailtauscher</strong> sind austauschbar.");
		break;

	case '0.0.8': // SQL queries for v0.0.8
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("Namenskonflikt gel&ouml;sst mit Erweiterung <strong>update</strong> (kommt noch raus!)");
		break;

	case '0.0.9': // SQL queries for v0.0.9
		// Update notes (these will be set as task text!)
		EXT_SET_UPDATE_NOTES("HTML-Code ausgelagert in Templates und SQL-Anweisungen abgesichert.");
		break;
	}
	break;

case 'modify': // When the extension got modified
	break;

case 'test': // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
	break;

default: // Do stuff when extension is loaded
	// Do we have a daily-reset-run?
	if (isResetModeEnabled() && (!isDebugModeEnabled()) && ($GLOBALS['output_mode'] != 1)) {
		// So let's check for profiles which needs an update
		ADD_INC_TO_POOL(sprintf("%sinc/profile-updte.php", constant('PATH')));
	}
	break;
}

//
?>
