<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 07/13/2004 *
 * ===============                              Last change: 08/02/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : overview-inc.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Output standard task management                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Standart-Aufgaben-Management ausgeben            *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

function OUTPUT_STANDARD_OVERVIEW(&$result_tasks) {
	// First check for solved and not assigned tasks and assign them to current admin
	SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_task_system` SET assigned_admin='%s' WHERE assigned_admin < 1 AND status != 'NEW'",
		array(GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);

	// We currently don't want to install an extension so let's find out if we need...
	$EXT_LOAD_MODE = 'register';
	$jobsDone = true;

	// Open the extension directory
	$extensionList = GET_DIR_AS_ARRAY("inc/extensions/", "ext-", false, false);
	foreach ($extensionList as $file) {
		// Is this file an extension?
		if ((substr($file, 0, 4) == "ext-") && (substr($file, -4) == ".php")) {
			//* DEBUG: */ echo $file."<br />\n";
			// Possible newly installed extension found so we extract extension's name
			$ext_name = strtolower(substr($file, 4, -4)); // Keep always extension names on lower case!!!

			// Init variables
			$result = false;

			// Check if extension is installed or not
			$ext_ver = GET_EXT_VERSION($ext_name);

			// Is the extension not yet installed?
			if (empty($ext_ver)) {
				// Generate subject line
				$ext_subj = sprintf("[%s:]", $ext_name);

				// We maybe want to install an extension so let's test-drive it...
				if (LOAD_EXTENSION($ext_name, $EXT_LOAD_MODE)) {
					// Create a task for newly installed extension
					CREATE_NEW_EXTENSION_TASK(GET_CURRENT_ADMIN_ID(), $ext_subj, $ext_name);
				} // END - if
			} else {
				// Test-drive extension in update mode
				require(sprintf("%sinc/extensions/ext-%s.php", constant('PATH'), $ext_name));

				// Update extension if extension is installed and outdated
				//* DEBUG: */ print "ext={$ext_name},ver={EXT_GET_VERSION()}/".GET_EXT_VERSION($ext_name)."<br />\n";
				if (EXT_GET_VERSION() > $ext_ver) {
					// Update the extension
					EXTENSION_UPDATE($ext_name, $ext_ver);
				} // END - if

				if (isset($GLOBALS['cache_array']['active_extensions'][$ext_name])) {
					// Maybe we want to keept the current extension active?
					if (($GLOBALS['cache_array']['active_extensions'][$ext_name] == 'Y') && (!EXT_IS_ACTIVE($ext_name))) {
						// Reactivate this extension!
						ACTIVATE_EXTENSION($ext_name);
					} // END - if
				} // END - if
			}
		} // END - if
	} // END - foreach

	// At last - but not least - check for own and new unassigned tasks...
	$result_tasks = SQL_QUERY_ESC("SELECT id, assigned_admin, userid, task_type, subject, text, task_created
FROM `{!_MYSQL_PREFIX!}_task_system`
WHERE assigned_admin='%s' OR (assigned_admin='0' AND `status`='NEW')
ORDER BY userid DESC, task_type DESC, subject, task_created DESC",
		array(GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);

	if (SQL_NUMROWS($result_tasks) > 0) {
		// New jobs found!
		$jobsDone = false;
	} // END - if

	// Free the result
	SQL_FREERESULT($result);

	// Return status
	return $jobsDone;
}

// Outputs selected tasks
function OUTPUT_SELECTED_TASKS ($POST, $result_tasks) {
	if ((isset($POST['assign'])) && (count($POST['task']) > 0)) {
		// Assign / do tasks
		$OUT = ''; $SW = 2;
		foreach ($POST['task'] as $id => $sel) {
			$result_task = SQL_QUERY_ESC("SELECT id, userid, task_type, subject, text, task_created, status, assigned_admin FROM `{!_MYSQL_PREFIX!}_task_system` WHERE id=%s AND (assigned_admin='%s' OR (assigned_admin='0' AND `status`='NEW')) LIMIT 1",
				array(bigintval($id), GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);
			if (SQL_NUMROWS($result_task) == 1) {
				// Task is valid...
				list($tid, $uid, $type, $subj, $text, $created, $status, $aid) = SQL_FETCHROW($result_task);
				SQL_FREERESULT($result_task);

				if ($aid == "0") {
					// Assgin current admin to unassgigned task
					SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_task_system` SET assigned_admin='%s' WHERE id=%s LIMIT 1",
						array(GET_CURRENT_ADMIN_ID(), bigintval($tid)), __FILE__, __LINE__);
				} // END - if

				$add = '';
				if ($type == "SUPPORT_MEMBER") {
					$mode = substr($text, 0, strpos($text, ":"));
					$text = substr($text, strpos($text, ":") + 1);
					$add = "<li>{--ADMIN_TASK_SUPPORT_MODE--}: <strong>".$mode."</strong></li>";
				} // END - if

				if ($uid > 0) {
					$result_user = SQL_QUERY_ESC("SELECT gender, surname, family, email FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
					 array(bigintval($uid)), __FILE__, __LINE__);
					if (SQL_NUMROWS($result_user) == 1) {
						list($gender, $sname, $fname, $email) = SQL_FETCHROW($result_user);
						SQL_FREERESULT($result_user);
						$add = "<li>{--ADMIN_MEMBER_UID--}: <strong>".ADMIN_USER_PROFILE_LINK($uid)." (<a href=\"".CREATE_EMAIL_LINK($email, "user_data")."\">".TRANSLATE_GENDER($gender)." ".$sname." ".$fname."</a>)</strong></li>";
					} // END - if
				} // END - if

				// Decode entities of the text
				$text = decodeEntities($text);

				// Compile and insert text from task into table template
				$text = LOAD_TEMPLATE("admin_extensions_text", true, $text);

				// Initialize variables (no title for SQL commands by default)
				$ext_name = '';
				$title = getMessage('TASK_NO_TITLE');

				// Shall I list SQL commands assigned to an extension installation or update task?
				if (((GET_EXT_VERSION('sql_patches') != '') && (getConfig('verbose_sql') == 'Y')) || (!EXT_IS_ACTIVE('sql_patches'))) {
					$ext_name = substr($subj, 1, strpos($subj, ":") - 1);
					if ($type == "EXTENSION") {
						// Load SQL commands for registering
						REGISTER_EXTENSION($ext_name, $id, true);

						// Add notes to text
						$text .= EXT_GET_NOTES();

						// Set title
						$title = getMessage('ADMIN_SQLS_EXECUTED_ON_REGISTER');
					} elseif ($type == "EXTENSION_UPDATE") {
						// Prepare extension name and version
						$ext_name = substr($ext_name, 7);
						$ext_name = substr($ext_name, 0, strpos($ext_name, "-"));
						$test = "[UPDATE-".$ext_name."-";
						$ext_ver = substr($subj, strlen($test));
						$ext_ver = substr($ext_ver, 0, strpos($ext_ver, ":"));

						// Load SQLs from file
						EXTENSION_UPDATE($ext_name, $ext_ver, true);

						// Add notes to text
						$text .= EXT_GET_NOTES();

						// Set title
						$title = getMessage('ADMIN_SQLS_EXECUTED_ON_UPDATE');
					} else {
						// Remove extension's name
						$ext_name = '';
					}

					// Add SQLs to a table
					if (!IS_SQLS_VALID()) INIT_SQLS();
					if (empty($title)) $title = '';
					if ((!empty($ext_name)) && (GET_EXT_VERSION('sql_patches')) && (getConfig('verbose_sql') == 'Y')) {
						// Add verbose SQL table
						$text .= EXTENSION_VERBOSE_TABLE($title, " class=\"admin_table top2 left2 right2\"", true, "100%")."<br />\n";
					} // END - if
				} else {
					// Run SQL commands in dry mode but only return the notes
					EXTENSION_UPDATE($ext_name, $ext_ver, true);
					$text .= EXT_GET_NOTES();
				}

				// Prepare array for the template
				$content = array(
					'sw'        => $SW,
					'subj'      => $subj,
					'add'       => $add,
					'text'      => $text,
					'created'   => MAKE_DATETIME($created, "1"),
					'extension' => $ext_name
				);

				// Load template
				$OUT .= LOAD_TEMPLATE("admin_overview_row", true, $content);

				// Which task do we actually have here?
				// @TODO Rewrite this to something with include files
				switch ($type)
				{
				case "EXTENSION": // Install new extensions
					$ext_name = substr($subj, 1, strpos($subj, ":") - 1);
					$result_lines = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_extensions` WHERE ext_name='%s' LIMIT 1",
						array($ext_name), __FILE__, __LINE__);
					$lines = SQL_NUMROWS($result_lines);
					SQL_FREERESULT($result_lines);
					if ($lines == "0") {
						// New extension found
						$OUT .= LOAD_TEMPLATE("admin_ext_reg_form", true, array(
							'id'       => bigintval($id),
							'ext_name' => $ext_name
						));
					} else {
						// Task is closed so nothing is todo
						$OUT .= "<div class=\"admin_failed\">{--ADMIN_EXT_ALREADY_REGISTERED--}</div>\n";

						// Close task but not already closes or deleted or update tasks
						if (($status != "CLOSED") && ($status != "DELETED") && ($type != "EXTENSION_UPDATE")) {
							// Solve the task
							runFilterChain('solve_task', $tid);
						} // END - if
					}
					break;

				case "EXTENSION_UPDATE": // Extension update
					// Extension updates are installed automatically
					$OUT .= "<div class=\"admin_failed medium\">{--ADMIN_EXTENSION_UPDATED--}</div>\n";

					// Close task
					if (($status != "CLOSED") && ($status != "DELETED")) {
						// Solve the task
						runFilterChain('solve_task', $tid);
					} // END - if
					break;

				case "SUPPORT_MEMBER": // Assign on member's support request
					// @TODO This may also be rewritten to include files
					switch ($mode)
					{
					default: // @TODO Unknown support mode
						DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown support mode %s detected. This part is under construction!", $mode));
						$OUT .= "<div class=\"admin_failed medium\">".sprintf(getMessage('ADMIN_UNKNOWN_SUPPORT_MODE'), $mode)."</div>\n";
						break;
					}
					break;

				case "PAYOUT_REQUEST": // Payout requests
					if (EXT_IS_ACTIVE('payout')) {
						// Extension is installed so let him send a notification to the user
						$result_pay = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_user_payouts` WHERE userid=%s AND payout_timestamp=%s LIMIT 1",
							array(bigintval($uid), bigintval($created)), __FILE__, __LINE__);
						list($pid) = SQL_FETCHROW($result_pay);
						SQL_FREERESULT($result_pay);

						if ((!empty($pid)) && ($pid > 0)) {
							// Payout ID can be obtained
							$content = array(
								'pid' => $pid,
								'tid' => $tid,
							);
							$OUT .= LOAD_TEMPLATE("admin_payout_overview_form", true, $content);
						} else {
							// Problem obtaining payout ID
							$OUT .= "<div class=\"admin_failed medium\">".PAYOUT_OBTAIN_ID_FAILED."</div>\n";
						}
					} else {
						// Extension is not installed
						$OUT .= "<div class=\"admin_failed medium\">{--ADMIN_PAYOUT_NOT_INSTALLED--}</div>\n";
					}
					break;

				case "WERNIS_REQUEST": // Wernis requests
					if (EXT_IS_ACTIVE('wernis')) {
						// Extension is installed so let him send a notification to the user
						$result_pay = SQL_QUERY_ESC("SELECT id FROM `{!_MYSQL_PREFIX!}_user_wernis` WHERE userid=%s AND wernis_timestamp=%s LIMIT 1",
							array(bigintval($uid), bigintval($created)), __FILE__, __LINE__);
						list($pid) = SQL_FETCHROW($result_pay);
						SQL_FREERESULT($result_pay);

						if ((!empty($pid)) && ($pid > 0)) {
							// Payout ID can be obtained
							$content = array(
								'pid' => $pid,
								'tid' => $tid,
							);
							$OUT .= LOAD_TEMPLATE("admin_wernis_overview_form", true, $content);
						} else {
							// Problem obtaining wernis ID
							$OUT .= "<div class=\"admin_failed medium\">{--WERNIS_OBTAIN_ID_FAILED--}</div>\n";
						}
					} else {
						// Extension is not installed
						$OUT .= "<div class=\"admin_failed medium\">{--ADMIN_WERNIS_NOT_INSTALLED--}</div>\n";
					}
					break;

				case "HOLIDAY_REQUEST": // Holiday requests
					$OUT .= LOAD_TEMPLATE("admin_task_holiday", true, $uid);
					break;

				case "NL_UNSUBSCRIBE": // Newsletter unsubscriptions
					$result = SQL_QUERY_ESC("SELECT nl_timespan FROM `{!_MYSQL_PREFIX!}_user_data` WHERE userid=%s LIMIT 1",
						array(bigintval($uid)), __FILE__, __LINE__);
					list($span) = SQL_FETCHROW($result);
					SQL_FREERESULT($result);

					if ($span > 0) {
						// Undone unscubscribe request
						$content = array(
							'uid' => $uid,
							'id'  => $tid
						);
						$OUT .= LOAD_TEMPLATE("admin_newsletter_tsk", true, $content);
					} else {
						// Already unsubscribed
						$OUT .= "<div class=\"admin_failed medium\">".ADMIN_NL_UNSUBSCRIBE_ALREADY."</div>\n";
					}
					break;

				default: // Unknown task type
					DEBUG_LOG(__FILE__, __LINE__, sprintf("Unknown task type %s detected.", $type));
					$OUT .= "<div class=\"admin_failed medium\">".sprintf(getMessage('ADMIN_UNKNOWN_TASK_TYPE'), $type, $id)."</div>\n";
					break;
				}
				$OUT .= "  </td>
  <td width=\"1%\" class=\"switch_sw".$SW." bottom2 right2\">&nbsp;</td>
</tr>\n";
			} // END - if
			$SW = 3 - $SW;
		} // END - foreach
		define('__TASK_ROWS', $OUT);

		// Load final template
		LOAD_TEMPLATE("admin_overview_list");
	} else {
		if ((isset($POST['task'])) && ((count($POST['task']) > 0) || ($POST['task'][0] == "1"))) {
			// Only unassign / delete tasks when there are selected tasks posted
			if (!empty($POST['unassign'])) {
				// Unassign from tasks
				foreach ($POST['task'] as $id => $sel) {
					SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_task_system` SET assigned_admin=0 WHERE id=%s AND assigned_admin=%s LIMIT 1",
						array(bigintval($id), GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);
				}
			} elseif (isset($POST['del'])) {
				// Delete tasks
				foreach ($POST['task'] as $id => $sel) {
					SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{!_MYSQL_PREFIX!}_task_system` WHERE id=%s AND assigned_admin IN (%s,0) LIMIT 1",
						array(bigintval($id), GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);
				}
			}

			// Update query
			$result_tasks = SQL_QUERY_ESC("SELECT id, assigned_admin, userid, task_type, subject, text, task_created FROM `{!_MYSQL_PREFIX!}_task_system` WHERE assigned_admin=%s OR (assigned_admin=0 AND `status`='NEW') ORDER BY task_created DESC",
				array(GET_CURRENT_ADMIN_ID()), __FILE__, __LINE__);
		} // END - if

		// There are uncompleted jobs!
		$OUT = ''; $SW = 2;
		while ($content = SQL_FETCHARRAY($result_tasks)) {
			// Init infos
			$content['infos'] = "---";

			// Generate assign link
			$content['assigned_admin'] = GENERATE_AID_LINK($content['assigned_admin']);

			// Generate infos
			switch ($content['task_type'])
			{
			case "EXTENSION":
			case "EXTENSION_UPDATE":
				$content['infos'] = substr($content['subject'], 1, strpos($content['subject'], ":") - 1);
				break;
			}

			// Get task type
			$content['task_type_msg'] = getMessage('ADMIN_TASK_IS_'.strtoupper($content['task_type']).'');

			if ($content['userid'] > 0) {
				// Member found otherwise it's a system task
				$content['userid'] = ADMIN_USER_PROFILE_LINK($content['userid']);
			} else {
				$content['userid'] = "<em>{--ADMIN_IS_SYSTEM_TASK--}</em>";
			}

			// Prepare content
			// @TODO Rewritings: admin->assigned_admin,uid->userid,type->task_type_msg in template
			$content = merge_array($content, array(
				'sw'      => $SW,
				'admin'   => $content['assigned_admin'],
				'uid'     => $content['userid'],
				'type'    => $content['task_type_msg'],
				'created' => MAKE_DATETIME($content['task_created'], "2")
			));

			// Do we have extension task?
			if (($content['task_type'] == "EXTENSION") && (GET_EXT_VERSION($content['infos']) == "")) {
				// Load extension row template
				$OUT .= LOAD_TEMPLATE("admin_overview_list_ext_rows", true, $content);
			} else {
				// Load default row template
				$OUT .= LOAD_TEMPLATE("admin_overview_list_rows", true, $content);
			}

			// Switch color
			$SW = 3 - $SW;
		}

		// Free memory
		SQL_FREERESULT($result_tasks);

		// Load footer template
		LOAD_TEMPLATE("admin_overview_table", false, $OUT);
	}
}
//
?>
