<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/27/2004 *
 * ================                             Last change: 08/27/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_mods.php                             *
 * -------------------------------------------------------------------- *
 * Short description : Module configuration                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Modul-Konfiguration                              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), '/inc') + 4) . '/security.php';
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

$SEL = 0;
if (REQUEST_ISSET_POST('edit')) {
	// Check if at least one module is selected
	$SEL = SELECTION_COUNT(REQUEST_POST('sel'));
	if ($SEL > 0) {
		// Output header
		$OUT = ''; $SW = 2;

		// Edit selected modules
		foreach (REQUEST_POST('sel') as $id => $sel) {
			// Load module data
			$result = SQL_QUERY_ESC("SELECT module, title, locked, hidden, admin_only, mem_only FROM `{!_MYSQL_PREFIX!}_mod_reg` WHERE id=%s LIMIT 1",
				array(bigintval($id)), __FILE__, __LINE__);
			list($mod, $title, $locked, $hidden, $admin, $mem) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);

			// Prepare array for the template
			$content = array(
				'sw'     => $SW,
				'mod'    => $mod,
				'id'     => $id,
				'title'  => $title,
				'locked' => ADD_SELECTION('yn', $locked, 'locked', $id),
				'hidden' => ADD_SELECTION('yn', $hidden, 'hidden', $id),
				'admin'  => ADD_SELECTION('yn', $admin , 'admin' , $id),
				'mem'    => ADD_SELECTION('yn', $mem   , 'member', $id),
			);

			// Load row template
			$OUT .= LOAD_TEMPLATE('admin_mods_edit_row', true, $content);
		}
		define('__MODS_ROWS', $OUT);

		// Load main template
		LOAD_TEMPLATE('admin_mods_edit');
	} else {
		// Nothing selected
		LOAD_TEMPLATE('admin_settings_saved', false, getMessage('MODS_NOTHING_SELECTED'));

		// Remove maybe confusing data
		REQUEST_UNSET_POST('edit');
		REQUEST_UNSET_POST('change');
	}
} elseif (REQUEST_ISSET_POST('change')) {
	// Init SQLs
	INIT_SQLS();

	// Change modules
	foreach (REQUEST_POST('sel') as $id => $sel) {
		// Secure ID number
		$id = bigintval($id);

		// Update module
		ADD_SQL(SQL_QUERY_ESC("UPDATE `{!_MYSQL_PREFIX!}_mod_reg` SET `title`='%s', `locked`='%s', `hidden`='%s', `admin_only`='%s', `mem_only`='%s' WHERE id=%s LIMIT 1",
			array(
				REQUEST_POST('title', $id),
				REQUEST_POST('locked', $id),
				REQUEST_POST('hidden', $id),
				REQUEST_POST('admin', $id),
				REQUEST_POST('member', $id),
				$id
			),  __FILE__, __LINE__, false));
	}

	// Run all sqls
	runFilterChain('run_sqls');

	// Remove cache file if version matches
	if (GET_EXT_VERSION('cache') >= '0.1.2') {
		if ($GLOBALS['cache_instance']->loadCacheFile('modreg')) $GLOBALS['cache_instance']->destroyCacheFile();
	} // END - if

	// Entries updated
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('MODS_CHANGED'));
}

if ($SEL == 0) {
	// Load module data (We do not need to check if there's at least one...)
	$result = SQL_QUERY('SELECT id, module, locked, hidden, admin_only, title, mem_only
FROM `{!_MYSQL_PREFIX!}_mod_reg`
ORDER BY module', __FILE__, __LINE__);
	$OUT = ''; $SW = 2;
	while ($content = SQL_FETCHARRAY($result)) {
		// Reset title to --- if it is NULL
		if (empty($content['title'])) $content['title'] = '---';
		if (($content['module'] == 'index') || ($content['module'] == 'login')) {
			// Add link to detail statistics
			$content['module'] = "<strong><a href=\"{!URL!}/modules.php?module=admin&amp;what=stats_mods&amp;mod=".$content['module']."\">".$content['module']."</a></strong>";
		}

		// Prepare array for the template
		// @TODO Rewritings: mod->module in template
		$content = array(
			'sw'     => $SW,
			'id'     => $content['id'],
			'mod'    => $content['module'],
			'title'  => $content['title'],
			'locked' => TRANSLATE_YESNO($content['locked']),
			'hidden' => TRANSLATE_YESNO($content['hidden']),
			'admin'  => TRANSLATE_YESNO($content['admin_only']),
			'mem'    => TRANSLATE_YESNO($content['mem_only']),
		);

		// Load row template
		$OUT .= LOAD_TEMPLATE('admin_mods_list_row', true, $content);

		// Switch colors
		$SW = 3 - $SW;
	}

	// Free memory
	SQL_FREERESULT($result);

	// @TODO Rewrite this constant
	define('__MODS_ROWS', $OUT);

	// Load main template
	LOAD_TEMPLATE('admin_mods_list');
}

//
?>
