<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/31/2008 *
 * ================                             Last change: 08/31/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_surfbar.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Configuration for surfbar                        *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Konfiguration fuer Surfbar                       *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

// Was the form submitted?
if (IS_FORM_SENT()) {
	// Replace german decimal comma with computer decimal dot
	if (REQUEST_ISSET_POST(('surfbar_static_reward')))   REQUEST_SET_POST('surfbar_static_reward'  , REVERT_COMMA(REQUEST_POST('surfbar_static_reward')));
	if (REQUEST_ISSET_POST(('surfbar_static_costs')))    REQUEST_SET_POST('surfbar_static_costs'   , REVERT_COMMA(REQUEST_POST('surfbar_static_costs')));
	if (REQUEST_ISSET_POST(('surfbar_dynamic_percent'))) REQUEST_SET_POST('surfbar_dynamic_percent', REVERT_COMMA(REQUEST_POST('surfbar_dynamic_percent')));

	// Save settings
	ADMIN_SAVE_SETTINGS_POST();
} else {
	// Prepare content
	$content = array(
		'surfbar_static_reward'   => TRANSLATE_COMMA(getConfig('surfbar_static_reward')),
		'surfbar_static_costs'    => TRANSLATE_COMMA(getConfig('surfbar_static_costs')),
		'surfbar_static_time'     => CREATE_TIME_SELECTIONS(getConfig('surfbar_static_time')   , "surfbar_static_time"   , "ms" , "left"),
		'surfbar_static_lock'     => CREATE_TIME_SELECTIONS(getConfig('surfbar_static_lock')   , "surfbar_static_lock"   , "hm" , "left"),
		'surfbar_restart_time'    => CREATE_TIME_SELECTIONS(getConfig('surfbar_restart_time')  , "surfbar_restart_time"  , "ms" , "left"),
		'surfbar_dynamic_percent' => TRANSLATE_COMMA(getConfig('surfbar_dynamic_percent')),
		'surfbar_max_order'       => getConfig('surfbar_max_order'),
		'surfbar_stats_reload'    => CREATE_TIME_SELECTIONS(getConfig('surfbar_stats_reload')  , "surfbar_stats_reload"  , "ms" , "left"),
		'surfbar_purge_deleted'   => CREATE_TIME_SELECTIONS(getConfig('surfbar_purge_deleted') , "surfbar_purge_deleted" , "WDh", "left"),
		'surfbar_purge_migrated'  => CREATE_TIME_SELECTIONS(getConfig('surfbar_purge_migrated'), "surfbar_purge_migrated", "WDh", "left"),
		'surfbar_pause_url'       => getConfig('surfbar_pause_url'),
		'surfbar_warn_low_points' => getConfig('surfbar_warn_low_points'),
		'surfbar_low_interval'    => CREATE_TIME_SELECTIONS(getConfig('surfbar_low_interval')  , "surfbar_low_interval"  , "WDh", "left"),
	);

	// Prepare payment model for template
	if (getConfig('surfbar_pay_model') == "STATIC") {
		// Static model
		define('__CONFIG_SURFBAR_PAY_MODEL_STATIC' , ' chkecked="checked"');
		define('__CONFIG_SURFBAR_PAY_MODEL_DYNAMIC', '');
	} else {
		// Dynamic model
		define('__CONFIG_SURFBAR_PAY_MODEL_STATIC' , '');
		define('__CONFIG_SURFBAR_PAY_MODEL_DYNAMIC', ' chkecked="checked"');
	}

	// Prepare auto-sart
	if (getConfig('surfbar_autostart') == 'Y') {
		// Yes selected
		define('__CONFIG_SURFBAR_AUTOSTART_Y', ' chkecked="checked"');
		define('__CONFIG_SURFBAR_AUTOSTART_N', '');
	} else {
		// No selected
		define('__CONFIG_SURFBAR_AUTOSTART_Y', '');
		define('__CONFIG_SURFBAR_AUTOSTART_N', ' chkecked="checked"');
	}

	// Prepare notify limits
	if (getConfig('surfbar_notify_limits') == 'Y') {
		// Yes selected
		define('__CONFIG_SURFBAR_NOTIFY_LIMITS_Y', ' chkecked="checked"');
		define('__CONFIG_SURFBAR_NOTIFY_LIMITS_N', '');
	} else {
		// No selected
		define('__CONFIG_SURFBAR_NOTIFY_LIMITS_Y', '');
		define('__CONFIG_SURFBAR_NOTIFY_LIMITS_N', ' chkecked="checked"');
	}

	// Prepare notify admin about unlocked emails
	if (getConfig('surfbar_notify_admin_unlock') == 'Y') {
		// Yes selected
		define('__CONFIG_SURFBAR_NOTIFY_ADMIN_UNLOCK_Y', ' chkecked="checked"');
		define('__CONFIG_SURFBAR_NOTIFY_ADMIN_UNLOCK_N', '');
	} else {
		// No selected
		define('__CONFIG_SURFBAR_NOTIFY_ADMIN_UNLOCK_Y', '');
		define('__CONFIG_SURFBAR_NOTIFY_ADMIN_UNLOCK_N', ' chkecked="checked"');
	}

	// Prepare order migration
	if (getConfig('surfbar_migrate_order') == 'Y') {
		// Yes selected
		define('__CONFIG_SURFBAR_MIGRATE_ORDER_Y', ' chkecked="checked"');
		define('__CONFIG_SURFBAR_MIGRATE_ORDER_N', '');
	} else {
		// No selected
		define('__CONFIG_SURFBAR_MIGRATE_ORDER_Y', '');
		define('__CONFIG_SURFBAR_MIGRATE_ORDER_N', ' chkecked="checked"');
	}

	// Pause URL mode
	if (getConfig('surfbar_pause_mode') == "INTERNAL") {
		// Internal pause page
		define('__CONFIG_SURFBAR_PAUSE_MODE_INTERNAL', ' chkecked="checked"');
		define('__CONFIG_SURFBAR_PAUSE_MODE_EXTERNAL', '');
	} else {
		// External pause page (if not empty)
		define('__CONFIG_SURFBAR_PAUSE_MODE_INTERNAL', '');
		define('__CONFIG_SURFBAR_PAUSE_MODE_EXTERNAL', ' chkecked="checked"');
	}

	// Notification mode
	if (getConfig('surfbar_notification_mode') == "INSTANT") {
		// Instant notification
		define('__CONFIG_SURFBAR_NOTIFICATION_MODE_INSTANT', " selected=\"selected\"");
		define('__CONFIG_SURFBAR_NOTIFICATION_MODE_RESET'  , '');
	} else {
		// Only daily reset
		define('__CONFIG_SURFBAR_NOTIFICATION_MODE_INSTANT', '');
		define('__CONFIG_SURFBAR_NOTIFICATION_MODE_RESET'  , " selected=\"selected\"");
	}

	// Load template
	LOAD_TEMPLATE("admin_config_surfbar", false, $content);
}

//
?>
