<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 03/22/2004 *
 * ================                             Last change: 12/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-extentions.php                              *
 * -------------------------------------------------------------------- *
 * Short description : Extension management                             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Erweiterungen-Management                         *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR('admin', __FILE__);

// Normally we want the overview of all registered theme_check
$mode = "overview";
$SEL = 0;

// Get response from our server
$response = GET_URL("check-themes.php");

// Are theme_check found?
if (($response[count($response) - 1] == "[EOF]") && ($response[0] != "[EOF]")) {
	// Ok, mark found and create the array
	$THEMES = array(
		'fname'  => array(), // File names
		'fsize'  => array(), // File size
		'fctime' => array(), // File creation timestamp
		'infos'  => array(), // File informations (maybe loaded!)
		'ver'    => array(), // Version number
		'cver'   => array(), // Current version number
	);

	// Get count of theme_check for validation
	$count = trim($response[count($response) - 2]);
	foreach ($response as $idx => $value) {
		$value = str_replace("\n", '', $value); $ver = '';

		// Leave loop when data is invalid or EOF?
		if ((substr($value, 0, 6) == "theme-") && (substr($value, -4) == ".zip")) {
			// Extract name and version
			$name = substr($value, 6, -4);
			$ver  = trim(substr($response[$idx + 3], 4));

			// Load version
			$cver = THEME_GET_VERSION($name);

			// Is the theme already installed or not?
			if (($ver != $cver) && ($cver != "?") && ($cver != "!")) {
				// No, it isn't. So let's add this one!
				$THEMES['fname'][]  = $name;
				$THEMES['fsize'][]  = $response[$idx + 1];
				$THEMES['fctime'][] = $response[$idx + 2];
				$THEMES['ver'][]    = $ver;
				$THEMES['cver'][]   = $cver;

				// Extract language strings from reponse
				$LANG_DUMMY = explode("[nl]", $response[$idx + 4]);
				$LANG = array();
				$INFO = getMessage('ADMIN_EXT_NO_INFO_FOUND');

				// Trim every data line
				foreach ($LANG_DUMMY as $k => $v) {
					$v = trim($v);
					if (substr($v, 3) == "") $v = "---";
					$LANG_DUMMY[$k] = $v;
					if ($v == "xx:xx") break;
					$LANG[] = $v;
				} // END - foreach

				// If language is found stop searching on matching line
				foreach($LANG as $search) {
					if (substr($search, 0, 3) == (GET_LANGUAGE().":")) { $INFO = substr($search, 3); break; }
				} // END - foreach

				// Add informations to array
				$THEMES['infos'][] = $INFO;
			} // END - if
		} // END - if
	} // END - foreach

	// Ok, themes are on our server but maybe you have already installed them?
	if (count($THEMES['fname']) > 0) {
		// Sort array (I missed ver and cver here)
		array_pk_sort($THEMES, array("cver", "fname"), 0, 1);

		// Extensions where found which are not downloaded and installed
		$OUT = ''; $SW = 2; $TSIZE = 0;
		foreach ($THEMES['fname'] as $idx => $name) {
			// Generate download link
			$LINK = SERVER_URL."/themes/theme-".$name.".zip";

			// @TODO Move this HTML code to a template "admin_theme_row"
			$OUT .= "<tr>
  <td align=\"center\" class=\"switch_sw".$SW." bottom2 right2\">".($idx + 1).".</td>
  <td align=\"center\" class=\"switch_sw".$SW." bottom2 right2\"><a href=\"".$LINK."\">".$name."</a></td>
  <td align=\"center\" class=\"switch_sw".$SW." bottom2 right2\">".MAKE_DATETIME($THEMES['fctime'][$idx], "2")."</td>
  <td align=\"center\" class=\"switch_sw".$SW." bottom2 right2\">".TRANSLATE_COMMA(round($THEMES['fsize'][$idx] / 1.024) / 1000)." ".KBYTES."</td>
  <td align=\"center\" class=\"switch_sw".$SW." bottom2\">".$THEMES['ver'][$idx]." (".$THEMES['cver'][$idx].")</td>
</tr>
<tr>
  <td class=\"switch_sw".$SW." bottom2\">&nbsp;</td>
  <td colspan=\"4\" class=\"switch_sw".$SW." bottom2\">
    <div class=\"tiny\">".$THEMES['infos'][$idx]."</div>
  </td>
</tr>\n";
			$TSIZE += $THEMES['fsize'][$idx];
			$SW = 3 - $SW;
		}
		define('__THEMES_ROWS', $OUT);
		define('__TKBYTES_VALUE', TRANSLATE_COMMA(round($TSIZE / 1.024) / 1000));
		define('__TTHEME_VALUE', count($THEMES['fname']));

		// Load template
		LOAD_TEMPLATE("admin_theme_list");
	} else {
		// All Themes are downloaded and installed
		LOAD_TEMPLATE("admin_theme_installed", false, $count);
	}
} else {
	// No theme where found
	LOAD_TEMPLATE('admin_settings_saved', false, getMessage('ADMIN_THEME_NOTHING_FOUND'));
}

//
?>
