<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 01/09/2005 *
 * ================                             Last change: 01/09/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-beg.php                                     *
 * -------------------------------------------------------------------- *
 * Short description : Beg link                                         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Bettel-Link                                      *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!IS_MEMBER()) {
	LOAD_URL('modules.php?module=index');
} elseif ((!EXT_IS_ACTIVE('beg')) && (!IS_ADMIN())) {
	addFatalMessage(__FILE__, __LINE__, getMessage('EXTENSION_PROBLEM_EXT_INACTIVE'), 'beg');
	return;
}

// Add description as navigation point
ADD_DESCR('member', __FILE__);

$uid = getUserId();
if (EXT_IS_ACTIVE('nickname'))
{
	// Load nickname
	$data = 'nickname';
}
 else
{
	// Load userid
	$data = 'userid';
}

// Run SQL command
$result = SQL_QUERY_ESC("SELECT ".$data.", beg_clicks
FROM `{!_MYSQL_PREFIX!}_user_data`
WHERE userid=%s
LIMIT 1", array($uid), __FILE__, __LINE__);
list($uid, $clicks) = SQL_FETCHROW($result);
SQL_FREERESULT($result);

// Set User-ID when no nickname was found
$nickname = true;
if (empty($uid)) { $uid = getUserId(); $nickname = false; }

// Prepare constants
define('__BEG_UID'        , $uid);
define('__BEG_CLICKS'     , $clicks);
define('__BEG_POINTS'     , TRANSLATE_COMMA(getConfig('beg_points')));
define('__BEG_POINTS_MAX' , TRANSLATE_COMMA(getConfig('beg_points_max')));
define('__BEG_TIMEOUT'    , CREATE_FANCY_TIME(getConfig('beg_timeout')));
define('__BEG_UID_TIMEOUT', CREATE_FANCY_TIME(getConfig('beg_uid_timeout')));

// Load template
LOAD_TEMPLATE("member_".substr(basename(__FILE__), 5, -4));

//
?>
