<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 11/09/2003 *
 * ===============                              Last change: 04/21/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-stats.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Statistics over send mails                       *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Statistik ueber gesendete Mails                  *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
} elseif (!IS_MEMBER()) {
	LOAD_URL('modules.php?module=index');
}

// Add description as navigation point
ADD_DESCR('member', __FILE__);

// Init output
$main_content = array();

// Load waiting/pending orders
$result = SQL_QUERY_ESC("SELECT id, cat_id, payment_id, subject, url, timestamp, target_send, data_type, zip
FROM `{!_MYSQL_PREFIX!}_pool`
WHERE sender=%s AND data_type != 'SEND'
ORDER BY timestamp DESC",
	array(getUserId()), __FILE__, __LINE__);

// Are there mails left in pool?
if (SQL_NUMROWS($result) > 0) {
	// Load all orders
	$OUT = ''; $SW = 2;
	while ($data = SQL_FETCHARRAY($result)) {
		// Is the ZIP code set? If not, set dashes
		if (empty($data['zip'])) $data['zip'] =  "---";

		// Prepare content for output
		$content = array(
			'sw'    => $SW,
			'id'    => $data['id'],
			'cat'   => GET_CATEGORY($data['cat_id']),
			'pay'   => GET_PAYMENT($data['payment_id']),
			'subj'  => COMPILE_CODE($data['subject']),
			'url'   => DEREFERER($data['url']),
			'stamp' => MAKE_DATETIME($data['timestamp'], "2"),
			'recs'  => $data['target_send'],
			'type'  => TRANSLATE_POOL_TYPE($data['data_type']),
			'zip'   => $data['zip']
		);

		// Load template
		$OUT .= LOAD_TEMPLATE("member_pool_row", true, $content);

		// Switch color
		$SW = 3 - $SW;
	} // END - if

	// Load main template
	$main_content['pool'] = LOAD_TEMPLATE("member_pool_table", true, $OUT);
} else {
	// No mails in pool!
	$main_content['pool'] = LOAD_TEMPLATE('admin_settings_saved', true, getMessage('MEMBER_NO_MAILS_IN_POOL'));
}

// Free result
SQL_FREERESULT($result);

// Load sent orders
//                               0     1         2         3      4            5            6            7           8
$result = SQL_QUERY_ESC("SELECT id, cat_id, payment_id, subject, url, timestamp_ordered, max_rec, timestamp_send, clicks
FROM `{!_MYSQL_PREFIX!}_user_stats`
WHERE userid=%s
ORDER BY timestamp_ordered DESC",
	array(getUserId()), __FILE__, __LINE__);

if (SQL_NUMROWS($result) > 0) {
	// Mail orders are in pool so we can display them
	$OUT = ''; $SW = 2;
	while ($data = SQL_FETCHROW($result)) {
		// Prepare data for the template
		$content = array(
			'sw'    => $SW,
			'cat'   => GET_CATEGORY($data[1]),
			'pay'   => GET_PAYMENT($data[2]),
			'subj'  => COMPILE_CODE($data[3]),
			'url'   => DEREFERER($data[4]),
			'stamp' => MAKE_DATETIME($data[5], "2"),
			'recs'  => $data[6],
			'sent'  => MAKE_DATETIME($data[7], "2"),
			'clix'  => $data[8],
			'perc'  => COMPILE_CODE($data[8] / $data[6] * 100)."%",
		);

		// Load row template and switch colors
		$OUT .= LOAD_TEMPLATE("member_stats_row", true, $content);
		$SW = 3 - $SW;
	}

	// Load main template
	$main_content['stats'] = LOAD_TEMPLATE("member_stats_table", true, $OUT);
} else {
	// No mail orders fond
	$main_content['stats'] = LOAD_TEMPLATE('admin_settings_saved', true, getMessage('MEMBER_NO_MAILS_IN_STATS'));
}

// Free result
SQL_FREERESULT($result);

// Load main template
LOAD_TEMPLATE("member_stats_pool", false, $main_content);

//
?>
