<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 08/25/2003 *
 * ===============                              Last change: 11/23/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : index.php                                        *
 * -------------------------------------------------------------------- *
 * Short description : Index page. A simple redirection to modules.php  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Index-Seite. Eine simple Weiterleitung auf die   *
 *           modules.php                                                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Load security stuff here (Oh, I hope this is not unsecure? Am I paranoia??? ;-) )
require('inc/libs/security_functions.php');

// Init "action" and "what"
$GLOBALS['what'] = '';
$GLOBALS['action'] = '';

// Set module
$GLOBALS['module'] = 'index';

// Set 'CSS-Mode'
$GLOBALS['output_mode'] = '0';

// Load config.php
require('inc/config.php');

// Is the script installed?
if (isInstalled()) {
	// Header
	LOAD_INC('inc/header.php');

	// Fix missing array elements here
	if (!isConfigEntrySet('index_delay'))  setConfigEntry('index_delay' , 0);
	if (!isConfigEntrySet('index_cookie')) setConfigEntry('index_cookie', 0);

	// Check for cookies
	if ((isSessionVariableSet('visited')) || (getConfig('index_delay') == 0) || (getConfig('index_cookie') == 0)) {
		// Is the index page configured for redirect pr not?
		if (getConfig('index_cookie') > 0) {
			// Set cookie and remeber it for specified time
			set_session('visited', 'true');
		} elseif (isSessionVariableSet('visited')) {
			// Remove cookie when admin set 0 in setup
			set_session('visited', '');
		}

		// Template laden
		LOAD_TEMPLATE('index', false, ADD_URL_DATA(''));

		// Shall I insert an automated forward?
		if (getConfig('index_delay') > 0) {
			// This will be a JavaScript-redirect!
			define('__DELAY_VALUE', (getConfig('index_delay') * 1000 + 500));
			define('__MOD_VALUE'  , ADD_URL_DATA('index'));
			LOAD_TEMPLATE('index_forward');
		} // END - if
	} else {
		// Redirect to main page
		LOAD_URL('modules.php?module=index');
	}

	// Footer
	LOAD_INC('inc/footer.php');
} else {
	// You have to install first!
	LOAD_URL('install.php');
}

// All done here...
shutdown();

//
?>
